package br.UFSC.GRIMA.acceptance;

import java.awt.Point;
import java.awt.Rectangle;
import java.util.ArrayList;

import jsdai.SMachining_schema.AAxis2_placement_3d;
import jsdai.SMachining_schema.ACartesian_point;
import jsdai.SMachining_schema.AExecutable;
import jsdai.SMachining_schema.AMachining_workingstep;
import jsdai.SMachining_schema.APlane;
import jsdai.SMachining_schema.EBlock;
import jsdai.SMachining_schema.EWorkpiece;
import jsdai.SMachining_schema.EWorkplan;
import jsdai.lang.ASdaiModel;
import jsdai.lang.A_double;
import jsdai.lang.EEntity;
import jsdai.lang.SdaiException;
import br.UFSC.GRIMA.Entity.Axis2Placement_3dReader;
import br.UFSC.GRIMA.Entity.BlockReader;
import br.UFSC.GRIMA.Entity.Cartesian_pointReader;
import br.UFSC.GRIMA.Entity.MachiningWorkingStepReader;
import br.UFSC.GRIMA.Entity.PlaneReader;
import br.UFSC.GRIMA.Entity.ProjectReader;
import br.UFSC.GRIMA.Entity.Round_holeReader;
import br.UFSC.GRIMA.Entity.WorkpieceReader;
import br.UFSC.GRIMA.Entity.WorkplanReader;
import br.UFSC.GRIMA.entidades.STEPHoleProject;

public class STEP_NCReader {
	String path;
	ProjectReader projectReader;

	public STEP_NCReader(ASdaiModel model) {
		projectReader = new ProjectReader(model);
	}

	public Rectangle getPieceProps() {
		try {
			EWorkpiece workpiece = projectReader.getWorkpiece();
			WorkpieceReader reader = new WorkpieceReader(workpiece);
			EBlock block = (EBlock) reader.getBounding_Geometry();
			BlockReader blockReader = new BlockReader(block);

			blockReader.getY();

			return new Rectangle((int) blockReader.getX(), (int) blockReader
					.getY());
		} catch (SdaiException e) {
			e.printStackTrace();
		}

		return null;
	}

	public ArrayList<A_double> getPoints() throws SdaiException {
		EWorkplan workplan = projectReader.getWorkplan();
		WorkplanReader reader = new WorkplanReader(workplan);
		AExecutable executable = reader.getMachiningWorkingSteps();
		MachiningWorkingStepReader machiningWorkingStepReader = new MachiningWorkingStepReader(
				executable);
		
		Round_holeReader round_holeReader = new Round_holeReader( machiningWorkingStepReader.getItsFeature());
		
		
		AAxis2_placement_3d axis2_placement_3d = round_holeReader.getFeaturePlacement();
		Axis2Placement_3dReader axis2Placement_3dReader = new Axis2Placement_3dReader(
				axis2_placement_3d);

		ACartesian_point cartesian_point = axis2Placement_3dReader
				.getCartesianPoint();
		Cartesian_pointReader cartesian_pointReader = new Cartesian_pointReader(
				cartesian_point);
		return cartesian_pointReader.getPosition();

	}
}
