package br.UFSC.GRIMA.cad;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JOptionPane;

import br.UFSC.GRIMA.cad.visual.RanhuraFrame;
import br.UFSC.GRIMA.capp.Ferramenta;
import br.UFSC.GRIMA.feature.Degrau;
import br.UFSC.GRIMA.feature.Face;
import br.UFSC.GRIMA.feature.Ranhura;


public class CriarRanhura extends RanhuraFrame implements ActionListener
{	public Face face = null;
	public int eixo = 0;
	public JanelaPrincipal parent;

	public CriarRanhura(JanelaPrincipal parent, Face face)
	{
		super(parent);

		this.face = face;
		this.parent = parent;
		//this.parent.setEnabled(false);
		this.init();
	}
	
	public void init(){
		this.adjustSize();
		this.adjustPosition();

		this.label10.setText(this.face.getTipoString());
		super.cancelButton.addActionListener(this);
		super.okButton.addActionListener(this);		
		super.radioButtonX.addActionListener(this);
		super.radioButtonY.addActionListener(this);
		
		this.setVisible(true);
	}
	
	public void adjustSize(){
		this.pack();
	}

	//centraliza a janela no desktop do usuario
	public void adjustPosition(){
		Toolkit toolkit = this.getToolkit();
		
		Dimension screenSize = toolkit.getScreenSize();
		Dimension size = this.getPreferredSize();

		int posX = (int)(screenSize.getWidth() - size.getWidth())/2;
		int posY = (int)(screenSize.getHeight() - size.getHeight())/2;

		this.setLocation(posX, posY);
		System.out.println(this.getLocation().toString());
	}
	
	
	public void actionPerformed(ActionEvent event) 
	{	Object origem = event.getSource();
		if (origem == okButton) 
		{	
			okSelecionado();
		}
		else
			if (origem == cancelButton)
			{	CancelSelecionado();
			}
		else
			if (origem == radioButtonX)
			{	
				eixo = 0;
				URL ranhuraHorizontalModelo = getClass().getResource("/images/ranhuraHorizontalModelo.GIF");
				this.labelImage.setIcon(new ImageIcon(ranhuraHorizontalModelo));
			}
		else
			if (origem == radioButtonY)
			{	
				eixo = 1;
				URL ranhuraVerticalModelo = getClass().getResource("/images/ranhuraVerticalModelo.GIF");
				this.labelImage.setIcon(new ImageIcon(ranhuraVerticalModelo));
			}		
	}
		
	private void CancelSelecionado() 
	{	
		this.parent.setEnabled(true);
		dispose();
	}
	private void okSelecionado() 
	{	boolean ok = true;
		double profundidade = 0.0;
		double largura = 0.0;
		double deslocamento = 0.0;
		double posicaoZ = 0.0;      
		double posX = 0, posY = 0, posZ = 0; 
		double diametroFresa = new Ferramenta().getDiametroFerramenta();
		
		/** ****** validacao dos dados introduzidos no campo "PROFUNDIDADE" ****** 
		 * 
		 */
		
		if (ok) {
			try {
				profundidade = Double.parseDouble(textField1.getText());
				if (profundidade > 0) {
					ok = true;
				} else {
					ok = false;
					JOptionPane.showMessageDialog(null,
							"Digite um N�mero positivo para a PROFUNDIDADE da Ranhura",
							"Erro na profundidade", JOptionPane.CANCEL_OPTION);
				}
			} catch (Exception e) {
				JOptionPane.showMessageDialog(null,
						"Digite um N�mero positivo para a PROFUNDIDADE da Ranhura",
						"Erro na PROFUNDIDADE", JOptionPane.CANCEL_OPTION);
				ok = false;
			}
		}
		
		/** ****** validacao dos dados introduzidos no campo "LARGURA" ****** 
		 * 
		 */
		
		if (ok) {
			try {
				largura = Double.parseDouble(textField2.getText());
				if (largura > 0 && largura >= diametroFresa) {
					
					ok = true;
				} else {
					ok = false;
					JOptionPane.showMessageDialog(null,
							"Verifique que a largura da ranhura seja maior ou igual � da ferramenta (" + diametroFresa + "mm)",
							"Erro na Largura", JOptionPane.CANCEL_OPTION);
				}
			} catch (Exception e) {
				JOptionPane.showMessageDialog(null,
						"Digite um N�mero positivo para a LARGURA da Ranhura",
						"Erro na LARGURA", JOptionPane.CANCEL_OPTION);
				ok = false;
			}
		}
/** ****** validacao dos dados introduzidos no campo "DESLOCAMENTO" ******
 * 
 */
		if (ok) {
			try {
				deslocamento = Double.parseDouble(formattedTextField1.getText());
				if (deslocamento > 0 ) {
					ok = true;
				} else {
					ok = false;
					JOptionPane.showMessageDialog(null,
							"Digite um N�mero positivo para o DESLOCAMENTO da Ranhura",
							"Erro no DESLOCAMENTO", JOptionPane.CANCEL_OPTION);
				}
			} catch (Exception e) {
				JOptionPane.showMessageDialog(null,
						"Digite um N�mero positivo para o DESLOCAMENTO da Ranhura",
						"Erro no DESLOCAMENTO", JOptionPane.CANCEL_OPTION);
				ok = false;
			}
		}
		/****** validacao dos dados introduzidos no campo "POSICAO Z" ****** 
		 * 
		 */
				if (ok) {
					try {
						posicaoZ = Double.parseDouble(textField3.getText());
						if (posicaoZ >= 0 && profundidade + posicaoZ < face.getProfundidadeMaxima()) {
							ok = true;
						} else {
							ok = false;
							JOptionPane.showMessageDialog(null,
									"Verifique que a profundidade nao ultrapasse a profundidade m�xima do bloco",
									"Erro no POOSI��O Z(001)", JOptionPane.CANCEL_OPTION);
						}
					} catch (Exception e) {
						JOptionPane.showMessageDialog(null,
								"Digite um N�mero positivo para o POSI��O Z da Ranhura",
								"Erro no POOSI��O Z", JOptionPane.CANCEL_OPTION);
						ok = false;
					}
				}
				if (ok)
				{
					switch (eixo)
					{	case 0:		/******HORIZONTAL**********/
							posX = 0;
							posY = deslocamento;
							posZ = posicaoZ;  
							break;
							
						case 1:					
							posX = deslocamento;
							posY = 0;
							posZ = posicaoZ;
							break;
							
						default:
							break;
					}
					Ranhura novaRanhura = new Ranhura();
					double X = 0, Y = 0, Z = 0;
					switch(this.face.verticeAtivado){
						case 0:
							
							X = posX;
							Y = posY;
							Z = posZ;
							novaRanhura.setEixo(this.eixo);
							if (novaRanhura.getEixo() == Ranhura.HORIZONTAL)
							{
								if (posY + largura > 0 && posY + largura < face.getLargura())
								{
									ok = true;
								}
								else
								{
									JOptionPane.showMessageDialog(null, "Verifique que a largura da ranhura esteja dentro dos limtites da face", 
											"Erro na largura", JOptionPane.CANCEL_OPTION);
									ok = false;
								}
							}
							else
							{
								if (posX + largura > 0 && posX + largura < face.getComprimento())
								{
									ok = true;
								}
								else
								{
									JOptionPane.showMessageDialog(null, "Verifique que a largura da ranhura esteja dentro dos limites da face"
											,"Erro na largura(001)", JOptionPane.CANCEL_OPTION);
									ok = false;
								}
							}
							break;
							
						case 1:
							if (eixo == 0)
							{
								novaRanhura.setEixo(Degrau.VERTICAL);
								X = deslocamento;
								Y = 0;
								Z = posZ; 
							}
							else
							{
								novaRanhura.setEixo(Degrau.HORIZONTAL);
								X = 0;
								Y = face.getLargura() - deslocamento - largura;
								Z = posZ;
							}
							if (novaRanhura.getEixo() == Ranhura.HORIZONTAL)
							{
								if (posX + largura > 0 && posX + largura < face.getLargura())
								{
									ok = true;
								}
								else
								{
									JOptionPane.showMessageDialog(null, "Verifique que a largura da ranhura esteja dentro dos limtites da face", 
											"Erro na largura", JOptionPane.CANCEL_OPTION);
									ok = false;
								}
							}
							else
							{
								if (posY + largura > 0 && posY + largura < face.getComprimento())
								{
									ok = true;
								}
								else
								{
									JOptionPane.showMessageDialog(null, "Verifique que a largura da ranhura esteja dentro dos limites da face"
											,"Erro na largura(001)", JOptionPane.CANCEL_OPTION);
									ok = false;
								}
							}
						break;	
						
						case 2:
							if (eixo == 0)
							{
								novaRanhura.setEixo(Degrau.HORIZONTAL);
								X = 0;
								Y = face.getLargura() - deslocamento - largura;
								Z = posZ;
							}
							else
							{
								novaRanhura.setEixo(Degrau.VERTICAL);
								X = face.getComprimento() - deslocamento - largura;
								Y = 0;
								Z = posZ;
							}
							if (novaRanhura.getEixo() == Ranhura.HORIZONTAL)
							{
								if (posY + largura > 0 && posY + largura < face.getLargura())
								{
									ok = true;
								}
								else
								{
									JOptionPane.showMessageDialog(null, "Verifique que a largura da ranhura esteja dentro dos limtites da face", 
											"Erro na largura(001a)", JOptionPane.CANCEL_OPTION);
									ok = false;
								}
							}
							else
							{
								if (posX + largura > 0 && posX + largura < face.getComprimento())
								{
									ok = true;
								}
								else
								{
									JOptionPane.showMessageDialog(null, "Verifique que a largura da ranhura esteja dentro dos limites da face"
											,"Erro na largura(002a)", JOptionPane.CANCEL_OPTION);
									ok = false;
								}
							}
							break;
							
						case 3:
							if (eixo == 0)
							{
								novaRanhura.setEixo(Degrau.VERTICAL);
								X = face.getComprimento() - deslocamento - largura;
								Y = 0;
								Z = posZ;
							}
							else
							{
								novaRanhura.setEixo(Degrau.HORIZONTAL);
								X = 0;
								Y = deslocamento;
								Z = posZ;
							}
							if (novaRanhura.getEixo() == Ranhura.HORIZONTAL)
							{
								if (posX + largura > 0 && posX + largura < face.getLargura())
								{
									ok = true;
								}
								else
								{
									JOptionPane.showMessageDialog(null, "Verifique que a largura da ranhura esteja dentro dos limtites da face", 
											"Erro na largura", JOptionPane.CANCEL_OPTION);
									ok = false;
								}
							}
							else
							{
								if (posY + largura > 0 && posY + largura < face.getComprimento())
								{
									ok = true;
								}
								else
								{
									JOptionPane.showMessageDialog(null, "Verifique que a largura da ranhura esteja dentro dos limites da face"
											,"Erro na largura(001)", JOptionPane.CANCEL_OPTION);
									ok = false;
								}
							}
							break;
						default:
							break;
					}
					if (ok)
					{
						novaRanhura.setLargura(largura);
						novaRanhura.setProfundidade(profundidade);
						novaRanhura.setPosicao(X, Y, Z);
						
						if (this.face.validarFeature(novaRanhura))
						{
							this.face.addFeature(novaRanhura);
							this.parent.desenhador.repaint();
							this.parent.atualizarArvore();
							//face.imprimeDados(novaRanhura);
							this.parent.setEnabled(true);
							dispose();
						}
						else
						{
							JOptionPane.showMessageDialog(null, "Erro na cria��o da Ranhura", "Feature inv�lida", JOptionPane.OK_CANCEL_OPTION);
						}
					}
		}
	}
}