package br.UFSC.GRIMA.capp;

import java.util.Vector;

import br.UFSC.GRIMA.cam.GerarCodigoHPGL;
import br.UFSC.GRIMA.feature.Cavidade;
import br.UFSC.GRIMA.feature.Degrau;
import br.UFSC.GRIMA.feature.Face;
import br.UFSC.GRIMA.feature.Feature;
import br.UFSC.GRIMA.feature.Furo;
import br.UFSC.GRIMA.feature.Ranhura;
import br.UFSC.GRIMA.util.DeterminadorDeTempo;
import br.UFSC.GRIMA.util.Ponto;

public class MapeadoraDeWorkingstep {
	private Vector faces;//recebe
	private CondicoesDeUsinagem condicoesDeUsinagem;
	private Vector workingsteps;//saida
	private Ferramenta ferramenta = new Ferramenta();

	public MapeadoraDeWorkingstep(Vector faces, CondicoesDeUsinagem condicoesDeUsinagem) {
		// TODO Auto-generated constructor stub
		this.faces = faces;
		this.condicoesDeUsinagem = condicoesDeUsinagem;
		this.mapearWorkingsteps();
		this.imprimirDados();
	}
	
	private void mapearWorkingsteps(){
		this.workingsteps = new Vector();
		this.ferramenta.setDiametoFerramenta(3);
		this.ferramenta.setProfundidadeMaxima(60);
		DeterminadorDeTempo dT = new DeterminadorDeTempo();
		
		/*for(faces){
		 * for(feataures)
		 *  adiciona no vetor referente a face
		 * }
		 * adiciona o vetor da face I no vetor de workingsteps
		 */
		for (int i = 0; i < faces.size(); i++)
		{
			Face faceTmp = (Face)faces.elementAt(i);
			
			Vector wsFace = new Vector();
			
			for (int j = 0; j < faceTmp.features.size(); j ++)
			{
				Feature featureTmp = (Feature)faceTmp.features.elementAt(j);
				Workingstep wsTmp = new Workingstep(featureTmp, faceTmp);
				wsTmp.setPontos(this.determinadorDePontos(wsTmp));
				System.out.println("getPontos(Z): " + wsTmp.getPontos()[0]);
				wsTmp.setInfoMovimentacao(this.determinarInfoMovimentacao(wsTmp));
				wsTmp.setCondicoesUsinagem(this.determinarCondicoesUsinagem(wsTmp));
				wsTmp.setFerramenta(this.ferramenta);
				wsFace.add(wsTmp); //adiciona no vetor de workingsteps
				//getFerramenta....();
				

				Vector movimentacao = DeterminarMovimentacao.getPontosMovimentacao(wsTmp);
				wsTmp.setPontosMovimentacao(movimentacao);
				//dT.determinarTempo(wsTmp);
				wsTmp.setTempo(DeterminadorDeTempo.determinarTempo(wsTmp));
				//GerarCodigoHPGL gc = new GerarCodigoHPGL(wsTmp);
				//System.out.println(GerarCodigoHPGL.gerarCodigo(wsTmp));

				//mandar imprimir os pontos
			}
			this.workingsteps.add(wsFace);// adiciona no vetor de faces
		}
	}
	
	public Ponto[] determinadorDePontos(Workingstep workingstep)
	{
		Feature feature = workingstep.getFeature();
		System.out.println("Dados br.UFSC.GRIMA.feature: " + feature.getTipoString()+ " posicao: " + feature.getPosicaoX() + " " + feature.getPosicaoY() + " " + feature.getPosicaoZ() + " ");
		workingstep.setFerramenta(new Ferramenta());
		Ponto[] ponto = null;
		boolean acabamento = false;
		double dZ = 3, x, y, z;
		switch(feature.getTipo())
		{
			case Feature.FURO:
				Furo furo = (Furo)feature;
				ponto = new Ponto[1];
				Ponto p = new Ponto(furo.getPosicaoX(), furo.getPosicaoY(), furo.getPosicaoZ() - dZ);
				ponto[0] = p;
				break;
			case Feature.DEGRAU:
				Degrau degrau = (Degrau)feature;
				ponto = new Ponto[4];
				if (acabamento)
				{
					//faz um negocio
				}
				else
				{
					if (degrau.getEixo() == Degrau.HORIZONTAL)
					{
						if(degrau.getPosicaoY() == 0)
						{
							x = degrau.getPosicaoX();
							y = degrau.getPosicaoY();
							z = degrau.getPosicaoZ() - dZ;
							ponto[0] = new Ponto(x, y, z);
							y = degrau.getLargura() - workingstep.getFerramenta().getDiametroFerramenta() / 2;
							ponto[1] = new Ponto(x, y, z);
							x = workingstep.getFaceMae().getComprimento();
							ponto[2] = new Ponto(x, y, z);
							y = degrau.getPosicaoY();
							ponto[3] = new Ponto(x, y, z);
						}
						else
						{
							x = degrau.getPosicaoX();
							y = workingstep.getFaceMae().getLargura();
							z = degrau.getPosicaoZ() - dZ;
							ponto[0] = new Ponto(x, y, z);
							y = degrau.getPosicaoY() + workingstep.getFerramenta().getDiametroFerramenta() / 2;
							ponto[1] = new Ponto(x, y, z);
							x = workingstep.getFaceMae().getComprimento();
							ponto[2] = new Ponto(x, y, z);
							y = workingstep.getFaceMae().getLargura();
							ponto[3] = new Ponto(x, y, z);
						}
					}
					else
					{
						if(degrau.getPosicaoX() == 0)
						{
							x = degrau.getPosicaoX();
							y = degrau.getPosicaoY();
							z = degrau.getPosicaoZ() - dZ;
							ponto[0] = new Ponto(x, y, z);
							y = workingstep.getFaceMae().getLargura();
							ponto[1] = new Ponto(x, y, z);
							x = degrau.getLargura() - workingstep.getFerramenta().getDiametroFerramenta() / 2;
							ponto[2] = new Ponto(x, y, z);
							y = degrau.getPosicaoY();
							ponto[3] = new Ponto(x, y, z);
						}
						else
						{
							x = workingstep.getFaceMae().getComprimento();
							y = degrau.getPosicaoY();
							z = degrau.getPosicaoZ() - dZ;
							ponto[0] = new Ponto(x, y, z);
							y = workingstep.getFaceMae().getLargura();
							ponto[1] = new Ponto(x, y, z);
							x = degrau.getPosicaoX() + workingstep.getFerramenta().getDiametroFerramenta() / 2;
							ponto[2] = new Ponto(x, y, z);
							y = degrau.getPosicaoY();
							ponto[3] = new Ponto(x, y, z);
						}
					}
				}
				break;
			case Feature.RANHURA:
				Ranhura ranhura = (Ranhura)feature;
				ponto = new Ponto[4];
				if (ranhura.getEixo() == Ranhura.HORIZONTAL)
				{
					if (acabamento)
					{
						
					}
					else
					{
						x = ranhura.getPosicaoX();
						y = ranhura.getPosicaoY() + workingstep.getFerramenta().getDiametroFerramenta() / 2;
						z = ranhura.getPosicaoZ() - dZ;
						Ponto rP0 = new Ponto(x, y, z);
						ponto[0] = rP0;
						y = ranhura.getPosicaoY() + ranhura.getLargura() - workingstep.getFerramenta().getDiametroFerramenta() / 2;
						Ponto rP1 = new Ponto(x, y, z);
						ponto[1] = rP1;
						x += workingstep.getFaceMae().getComprimento();
						Ponto rP2 = new Ponto(x, y, z);
						ponto[2] = rP2;
						y = ranhura.getPosicaoY() + workingstep.getFerramenta().getDiametroFerramenta() / 2;
						Ponto rP3 = new Ponto(x, y, z);
						ponto[3] = rP3;
					}
				}
				else
				{
					if (acabamento)
					{
						
					}
					else
					{
						x = ranhura.getPosicaoX() + workingstep.getFerramenta().getDiametroFerramenta() / 2;
						y = ranhura.getPosicaoY();
						z = ranhura.getPosicaoZ() - dZ;
						Ponto rP0 = new Ponto(x, y, z);
						ponto[0] = rP0;
						y += workingstep.getFaceMae().getLargura();
						Ponto rP1 = new Ponto(x, y, z);
						ponto[1] = rP1;
						x = ranhura.getPosicaoX() + ranhura.getLargura() - workingstep.getFerramenta().getDiametroFerramenta() / 2;
						Ponto rP2 = new Ponto(x, y, z);
						ponto[2] = rP2;
						y -= workingstep.getFaceMae().getLargura();
						Ponto rP3 = new Ponto(x, y, z);
						ponto[3] = rP3;
					}
				}
				break;
			case Feature.CAVIDADE:
				ponto = new Ponto[2];
				Cavidade cavidade = (Cavidade)feature;
				z = cavidade.getPosicaoZ() - dZ;
				if (cavidade.getLargura() < cavidade.getComprimento())
				{
					x = cavidade.getPosicaoX() + cavidade.getLargura() / 2;
					y = cavidade.getPosicaoY() + cavidade.getLargura() / 2;
					ponto[0] = new Ponto(x, y, z);
					x = 0;
					x = cavidade.getPosicaoX() + cavidade.getComprimento() - cavidade.getLargura() / 2;
					ponto[1] = new Ponto(x, y, z);
				}
				else
				{
					x = cavidade.getPosicaoX() + cavidade.getComprimento() / 2;
					y = cavidade.getPosicaoY() + cavidade.getComprimento() / 2;
					ponto[0] = new Ponto(x, y, z);
					y = 0;
					y = cavidade.getPosicaoY() + cavidade.getLargura() - cavidade.getComprimento() / 2;
					ponto[1] = new Ponto(x, y, z);
				}
				
				break;
			default:
				break;
		}
		/*for(int pointIndex = 0; pointIndex < ponto.length; pointIndex++){
			System.out.println("ponto[" + pointIndex + "] = " + ponto[pointIndex].getX() + " " + ponto[pointIndex].getY() + " " + ponto[pointIndex].getZ());
		}*/
		
		return ponto;
	}
	
	public Vector getWorkingsteps()
	{
		return this.workingsteps;
	}
	
	public InfoMovimentacao determinarInfoMovimentacao(Workingstep ws)
	{
		InfoMovimentacao infoMovimentacao = new InfoMovimentacao();
		Feature feature = ws.getFeature();
		switch (feature.getTipo())
		{
			case Feature.FURO:
				infoMovimentacao.setTipo(InfoMovimentacao.RADIAL_FURO);
				break;
			case Feature.DEGRAU:
				infoMovimentacao.setTipo(InfoMovimentacao.ZIG_ZAG);
				break;
			case Feature.RANHURA:
				infoMovimentacao.setTipo(InfoMovimentacao.ZIG_ZAG);
				break;
			case Feature.CAVIDADE:
				infoMovimentacao.setTipo(InfoMovimentacao.RADIAL_CAVIDADE);
				break;
			default:
				break;
		}
		return infoMovimentacao;
	}
	
	public CondicoesDeUsinagem determinarCondicoesUsinagem(Workingstep ws)
	{
		return this.condicoesDeUsinagem;
	}
	
	public void imprimirDados(){		
		System.out.println("\n");
		System.out.println("=======================================================");
		System.out.println("==        Dados da Mapeadora de Workingsteps         ==");
		System.out.println("=======================================================");
		
		for(int i = 0; i < this.workingsteps.size(); i++){
			Vector workingstepsFaceI = (Vector)this.workingsteps.elementAt(i);
			
			System.out.printf("..:: Face #%d (possui %d workingsteps) ::..", i, workingstepsFaceI.size());
			
			for(int j = 0; j < workingstepsFaceI.size(); j++){
				Workingstep wsJ = (Workingstep)workingstepsFaceI.elementAt(j); 

				System.out.printf("\tWorkingstep #%d\n", j);
				System.out.println(wsJ.getDados("\t"));
				
			}
			System.out.println("\n");
		}
		
		System.out.println("=======================================================");
	}
}
