package br.UFSC.GRIMA.capp;

import java.util.Vector;

import br.UFSC.GRIMA.feature.Face;
import br.UFSC.GRIMA.feature.Feature;
import br.UFSC.GRIMA.util.DeterminadorDeTempo;
import br.UFSC.GRIMA.util.PassaParaString;
import br.UFSC.GRIMA.util.Ponto;

public class Workingstep {
	private Feature feature;
	private Face faceMae;
	private Ferramenta ferramenta;
	private InfoMovimentacao infoMovimentacao;
	private CondicoesDeUsinagem condicoesUsinagem;
	private Ponto[] pontos;//todos os pontos de possiveis incios de usinagem
	private Ponto pontoInicial;//para o inicio da usinagem
	private Ponto pontoFinal;//ponto que a ferramenta deve ir quando terminar a usinagem
	private Vector movimentacao;
	//private DeterminadorDeTempo dT;
	private int tempo;
	
	public Workingstep(Feature feature, Face faceMae){
		this.feature = feature;
		this.faceMae = faceMae;
	}
	public CondicoesDeUsinagem getCondicoesUsinagem() {
		return condicoesUsinagem;
	}
	public void setCondicoesUsinagem(CondicoesDeUsinagem condicoesUsinagem) {
		this.condicoesUsinagem = condicoesUsinagem;
	}
	public Feature getFeature() {
		return feature;
	}
	public void setFeature(Feature feature) {
		this.feature = feature;
	}
	public InfoMovimentacao getInfoMovimentacao() {
		return infoMovimentacao;
	}
	public void setInfoMovimentacao(InfoMovimentacao infoMovimentacao) {
		this.infoMovimentacao = infoMovimentacao;
	}
	public Face getFaceMae() {
		return faceMae;
	}
	public void setFaceMae(Face faceMae) {
		this.faceMae = faceMae;
	}
	public Ponto getPontoFinal() {
		return pontoFinal;
	}
	public void setPontoFinal(Ponto pontoFinal) {
		this.pontoFinal = pontoFinal;
	}
	public Ponto getPontoInicial() {
		return pontoInicial;
	}
	public void setPontoInicial(Ponto pontoInicial) {
		this.pontoInicial = pontoInicial;
	}
	public Ponto[] getPontos() {
		return pontos;
	}
	public void setPontos(Ponto[] pontos) {
		this.pontos = pontos;
	}
	public void setFerramenta(Ferramenta ferramenta)
	{
		this.ferramenta = ferramenta;
	}
	public Ferramenta getFerramenta()
	{
		return this.ferramenta;
	}
	public void setPontosMovimentacao(Vector movimentacao)
	{
		this.movimentacao = movimentacao;
	}
	public Vector getPontosMovimentacao()
	{
		return this.movimentacao;
	}
	public void setTempo(int tempo)
	{
		this.tempo = tempo;
	}
	public int getTempo()
	{
		return this.tempo;
	}
	public String getDados(String tab){
		String saida = "";
		saida += (tab + " Feature:\n");
		saida += PassaParaString.featureToString(this.feature, tab + tab);
		
		Ponto[] pontosTmp = this.getPontos();
		saida += (tab + " Pontos de Controle:\n");
		for(int i = 0; i < pontosTmp.length; i++){
			saida += (tab + tab + pontosTmp[i].getDados());
		}
		
		CondicoesDeUsinagem cuTmp = this.getCondicoesUsinagem();
		saida += (tab + " Condi��es de Usinagem:\n");
		saida += (tab + tab + "Ae = " + cuTmp.getAe() + "\n");
		saida += (tab + tab + "Af = " + cuTmp.getAf() + "\n");
		saida += (tab + tab + "Ap = " + cuTmp.getAp() + "\n");
		saida += (tab + tab + "F = " + cuTmp.getF() + "\n");
		saida += (tab + tab + "N = " + cuTmp.getN() + "\n");
		saida += (tab + tab + "Vc = " + cuTmp.getVc() + "\n");
		saida += (tab + tab + "Vf = " + cuTmp.getVf() + "\n");
		
		Ferramenta fTmp = this.getFerramenta();
		saida += (tab + " Ferramenta Utilizada:\n");
		saida += (tab + tab + "Diametro = " + fTmp.getDiametroFerramenta() + "\n");
		saida += (tab + tab + "Profundidade Maxima = " + fTmp.getProfundidadeMaxima() + "\n");
		
		InfoMovimentacao infoTmp = this.getInfoMovimentacao();
		saida += (tab + " Info Movimenta��o:\n");
		saida += (tab + tab + infoTmp.getTipoString() + "\n");
		
		saida += (tab + " Tempo de Usinagem = " + this.getTempo() + "\n");

		return saida;
	}
}
