package br.UFSC.GRIMA.feature;

import java.io.Serializable;
import java.util.Vector;

public class Feature implements Serializable{
	public final static int FURO = 0;
	public final static int DEGRAU = 1;
	public final static int RANHURA = 2;
	public final static int CAVIDADE = 3;
	public int tipo = 0;
	public double X = 0.0, Y = 0, Z = 0.0;// ponto de referencia para criar qualquer br.UFSC.GRIMA.feature(FURO, DEGRAU, RANHURA,CAVIDADE)
	public Feature featureMae = null;
	public Vector featuresAnteriores = null;
	private int indice = 0;
	
	public Feature(int tipo){
		this.setTipo(tipo);
	}
	public boolean setTipo(int tipo){
		if(tipo >=0 && tipo <= 3){
			this.tipo = tipo;
			return true;
		}
		else
			return false;
	}
	public void setPosicao(double X, double Y, double Z){//reemplazei os "pos" por X,Y,Z
		this.X = X;
		this.Y = Y;
		this.Z = Z;
	}
	public double getPosicaoX()	
	{	return this.X;
	}
	public double getPosicaoY()
	{	return this.Y;
	}
	public double getPosicaoZ()
	{	return this.Z;
	}
	public int getTipo()
	{	return this.tipo;
	}
	public void setIndice(int indice)
	{
		this.indice = indice;
	}
	public int getIndice()
	{
		return this.indice;
	}
	public Vector getFeaturesAnteriores() {
		return featuresAnteriores;
	}
	public void setFeaturesAnteriores(Vector featuresAnteriores) {
		this.featuresAnteriores = featuresAnteriores;
	}
	public String getTipoString()
	{
		switch (this.tipo)
		{
			case Feature.FURO:
				return "Furo";
			case Feature.DEGRAU:
				return "Degrau";
			case Feature.RANHURA:
				return "Ranhura";
			case Feature.CAVIDADE:
				return "Cavidade";
			default:
				return "";
		}
	}
	
	public String toString(){
		String saida = this.getTipoString() + " (" + this.getIndice() + ")";
		
		return saida;
	}
	
	public String getDados1(){
		String saida = "Feature ---------\n";
		saida += this.toString();
		
		if(this.featureMae != null){
			saida += "\tMae: " + this.featureMae.toString();
		}
		if(this.featuresAnteriores != null){
			for(int i = 0; i < this.featuresAnteriores.size(); i++){
				saida += "\tAnterior" + i + ": " + ((Feature)this.featuresAnteriores.elementAt(i)).toString();
			}
		}
		saida += "\n";
		
		return saida;
	}
}
 	