package br.UFSC.GRIMA.simulator;

//File: animation/bb/BallModel.java
//Description: The logic / model of a ball.
//Author: Fred Swartz
//Date:   February 2005

import java.awt.*;

///////////////////////////////////////////////////////////////// BallModel
public class Tool {
 //... Constants
 final static int DIAMETER = 15;
 
 //... Instance variables
 private double m_x;           // x and y coordinates upper left
 private double m_y;
 
 private double poitMarkX;
 private double poitMarkY;
 
 private double m_velocityX;   // Pixels to move each time move() is called.
 private double m_velocityY;
 private double velocity = 2;
 
 public double getVelocity() {
	return velocity;
}

public void setVelocity(double velocity) {
	velocity = velocity*2;
	velocity = velocity/50;
	this.velocity = velocity;
}

private int m_rightBound;  // Maximum permissible x, y values.
 private int m_bottomBound;
 
 //======================================================== constructor
 public Tool(int x, int y, int velocityX, int velocityY) {
     m_x = x;
     m_y = y;
     m_velocityX = velocityX;
     m_velocityY = velocityY;
     setNewPointMark();
 }
 
 //======================================================== setBounds
 public void setBounds(int width, int height) {
     m_rightBound  = width  - DIAMETER;
     m_bottomBound = height - DIAMETER;
 }
 
 //============================================================== draw
 public void draw(Graphics g) {
     g.fillOval(((int)m_y- DIAMETER/2),(int)(m_x - DIAMETER/2), DIAMETER, DIAMETER);
 }
 
 //============================================= getDiameter, getX, getY
 public int  getDiameter() { return DIAMETER;}
 public double  getX()        { return  m_x;}
 public double  getY()        { return  m_y;}
 
 //======================================================== setPosition
 public void setPosition(int x, int y) {
     m_x = x;
     m_y = y;
 }

public void moveX(int nextX,int nextY) {
	double hyp = Math.hypot((nextX - poitMarkX), (nextY - poitMarkY));
	double actualMovement = (nextX - poitMarkX)/hyp;
	m_x+=(velocity*actualMovement);
}

public void moveY(int nextX,int nextY) {
	double hyp = Math.hypot((nextX - poitMarkX), (nextY - poitMarkY));
	double actualMovement = (nextY - poitMarkY)/hyp;
	m_y+= (velocity*actualMovement);
}

public void setNewPointMark() {
	poitMarkX = m_x;
	poitMarkY = m_y;	
}

}
