package br.UFSC.GRIMA.util.projeto;

import java.io.Serializable;
import java.util.Vector;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;

import br.UFSC.GRIMA.feature.Bloco;



/**
 * Classe que possui todas as informa��es relativas ao projeto do
 * usu�rio.
 * 
 * Esta classe � armazenada no banco de dados.
 * 
 * @author roman
 *
 */
public class Projeto implements Serializable{
	private Bloco bloco;
	private Maquina maquina;
	private DadosDeProjeto dadosDeProjeto;
	private Vector ordensDeFabricacao = null;


	
	public Projeto(Maquina maquina, Bloco bloco, DadosDeProjeto dados){
		this.bloco = bloco;
		this.maquina = maquina;
		this.dadosDeProjeto = dados;
	}
	
	public JTree getJTree()
	{
		DefaultMutableTreeNode root = new DefaultMutableTreeNode
			("Projeto: " + dadosDeProjeto.getProjectName());
		root.add(this.maquina.getNodo());
		root.add(this.bloco.getNodo1());
		root.add(this.bloco.getNodo());
		
		return new JTree(root);
	}
	
	public Bloco getBloco(){
		return this.bloco;
	}
	
	public Maquina getMaquina(){
		return this.maquina;
	}
	
	public Vector getOrdensDeFabricacao(){
		return this.ordensDeFabricacao;
	}
	
	public DadosDeProjeto getDadosDeProjeto(){
		return this.dadosDeProjeto;
	}
	
	public void addOrdemDeFabricacao(OrdemDeFabricacao ordem){
		if(this.ordensDeFabricacao == null)
			this.ordensDeFabricacao = new Vector();
		
		this.ordensDeFabricacao.add(ordem);
	}
}