package br.UFSC.GRIMA.entidades;

import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;
import jsdai.lang.SdaiException;

import org.junit.After;
import org.junit.Test;

public class STEPHoleProjectTest {

	@Test
	public void createSimpleHoleProject() {
		try {
			STEPHoleProject project = ProjectManager.getHoleProject();
			ProjectManager.setToolType(0);

			project.setProject("Hole");

			project.setMaterial("St50", "Stahl", "E210000 N/MM^2");

			project.setWorkPiece("Bauteil1", 110.000, 110.000, 40.000);

			project.addHoleWorkingStep("Hole0", 0.01, 50.000, 50.000, 50.000);

			project.addHoleWorkingStep("Hole1", 0.02, 80.000, 80.000, 50.000);

			project.addHoleWorkingStep("Hole2", 0.03, 90.000, 90.000, 50.000);

			project.relationateHoleVars();
			project.createSTEP21File();
			project.closeSession();

		} catch (Exception e) {
			e.printStackTrace();
			fail();
		}
		assertTrue(true);
	}

	@Test
	public void removeWorkingStepTest() {
		try {
			STEPHoleProject project = ProjectManager.resetProject();
			ProjectManager.setToolType(0);

			project.setProject("Hole");

			project.setMaterial("St50", "Stahl", "E210000 N/MM^2");

			project.setWorkPiece("Bauteil1", 110.000, 110.000, 40.000);

			project.addHoleWorkingStep("Hole0", 0.01, 50.000, 50.000, 50.000);

			project.addHoleWorkingStep("Hole1", 0.02, 80.000, 80.000, 50.000);

			project.addHoleWorkingStep("Hole2", 0.03, 90.000, 90.000, 50.000);

			project.removeWorkingStep(0);

			project.relationateHoleVars();
			project.createSTEP21File();
			project.closeSession();

		} catch (Exception e) {
			e.printStackTrace();
			fail();
		}
		assertTrue(true);
	}


}
