package br.UFSC.GRIMA.Entity;

import static org.junit.Assert.fail;
import jsdai.SMachining_schema.AAxis2_placement_3d;
import jsdai.SMachining_schema.ACartesian_point;
import jsdai.SMachining_schema.AExecutable;
import jsdai.SMachining_schema.APlane;
import jsdai.SMachining_schema.EAxis2_placement_3d;
import jsdai.SMachining_schema.ECartesian_point;
import jsdai.SMachining_schema.EWorkplan;
import jsdai.lang.SdaiException;
import junit.framework.Assert;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import br.UFSC.GRIMA.STEPmanager.Util;

public class Axis2Placement_3dReaderTest {
	Util util = new Util();
	ProjectReader projectReader;
	WorkplanReader workplanReader;
	MachiningWorkingStepReader workingStepReader;
	AExecutable aMachiningWorkingstep;
	APlane aPlane;
	PlaneReader planeReader;
	AAxis2_placement_3d aAxis2Placement_3d;
	Axis2Placement_3dReader aAxis2Placement_3dReader ;
	@Before
	public void startObjects() {
		try {
			projectReader = new ProjectReader(util.openFile21(Util
					.getUserPath()
					+ "test\\res\\STEP-NC File.p21"));
			EWorkplan eWorkplan = projectReader.getWorkplan();
			workplanReader = new WorkplanReader(eWorkplan);
			aMachiningWorkingstep = workplanReader.getMachiningWorkingSteps();
			workingStepReader = new MachiningWorkingStepReader(aMachiningWorkingstep);
			aPlane = workingStepReader.getAPlanes();
			planeReader = new PlaneReader(aPlane);
			aAxis2Placement_3d = planeReader.getAAxis2_Placement_3d();
			aAxis2Placement_3dReader = new Axis2Placement_3dReader(aAxis2Placement_3d);
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@After
	public void closeProject() {
		try {
			util.closeProject();
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void getCartesianPointsTest() {
		ACartesian_point aCartesianPoint = aAxis2Placement_3dReader.getCartesianPoint();
		try {
			Assert.assertTrue(((ECartesian_point)aCartesianPoint.getByIndex(1)).getCoordinates(null).getByIndex(3)==60.0);
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}

	}
}
