package br.UFSC.GRIMA.Entity;

import static org.junit.Assert.*;
import jsdai.SMachining_schema.AExecutable;
import jsdai.SMachining_schema.AMachining_operation;
import jsdai.SMachining_schema.AManufacturing_feature;
import jsdai.SMachining_schema.APlane;
import jsdai.SMachining_schema.EPlane;
import jsdai.SMachining_schema.ERound_hole;
import jsdai.SMachining_schema.EWorkplan;
import jsdai.lang.SdaiException;
import junit.framework.Assert;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import br.UFSC.GRIMA.STEPmanager.Util;

public class MachininigWorkinstepReaderTest {

	Util util = new Util();
	ProjectReader projectReader;
	WorkplanReader workplanReader;
	MachiningWorkingStepReader workingStepReader;
	AExecutable aMachiningWorkingstep;
	
	@Before
	public void startObjects() {
		try {
			projectReader = new ProjectReader(util.openFile21(Util
					.getUserPath()
					+ "test\\res\\STEP-NC File.p21"));
			EWorkplan eWorkplan = projectReader.getWorkplan();
			workplanReader = new WorkplanReader(eWorkplan);
			aMachiningWorkingstep =  workplanReader.getMachiningWorkingSteps();
			workingStepReader = new MachiningWorkingStepReader(aMachiningWorkingstep);
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}
	
	@Test
	public void getItsIdTest() {
		String itsId;
		itsId = workingStepReader.getItsId().get(0);
		Assert.assertEquals("Bohrung", itsId);
	}
	@Test
	public void getPlanesTest(){
		APlane aPlane = workingStepReader.getAPlanes();
		try {
			Assert.assertTrue(((EPlane)aPlane.getByIndex(1)).getName(null).equals(""));
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}
	
	@Test
	public void getItsFeatureTest(){
		AManufacturing_feature aManufacturingFeature = workingStepReader.getItsFeature();
		try{
			ERound_hole eRoundHole = (ERound_hole)aManufacturingFeature.getByIndex(1);
			Assert.assertTrue(eRoundHole.getIts_id(null).equals("Bohrung 20mm"));	
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}
	
	@Test
	public void getItsOperation() {
		AMachining_operation aMachiningOperation = workingStepReader.getItsMachiningOperation();
		try {
			Assert.assertTrue(aMachiningOperation.getByIndex(1).getIts_id(null).equals("Bohrung 20mm"));
		} catch (SdaiException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			fail();
		}
	}
	
	@After
	public void closeProject() {
		try {
			util.closeProject();
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}
	
}
