package br.UFSC.GRIMA.Entity;

import br.UFSC.GRIMA.STEPmanager.Util;
import jsdai.SMachining_schema.AProject;
import jsdai.SMachining_schema.AWorkpiece;
import jsdai.SMachining_schema.EProject;
import jsdai.SMachining_schema.EWorkpiece;
import jsdai.SMachining_schema.EWorkplan;
import jsdai.lang.ASdaiModel;
import jsdai.lang.SdaiException;
import jsdai.lang.SdaiIterator;
import jsdai.lang.SdaiModel;

public class ProjectReader {
	ASdaiModel aSdaiModel;
	EProject eProject;
	EWorkplan eWorkplan;
	AWorkpiece aWorkpiece;
	EWorkpiece eWorkpiece;
	
	public ProjectReader(ASdaiModel model) {
		aSdaiModel = model;
		try {
			getProject();
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}
	
	public ProjectReader(String path) {
		aSdaiModel = openFile21(path);
	}

	public ASdaiModel openFile21(String sourcePath){
		Util util = new Util();
		try {
			return util.openFile21(sourcePath);
		} catch (SdaiException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public EProject getProject() throws SdaiException {

		SdaiIterator modelIterator = aSdaiModel.createIterator();

		while (modelIterator.next()) {

			SdaiModel model = aSdaiModel.getCurrentMember(modelIterator);
			if (model.getMode() == SdaiModel.NO_ACCESS) {
				model.startReadOnlyAccess();
			}
			AProject aProject = (AProject) model.getInstances(EProject.class);

			SdaiIterator projectIterator = aProject.createIterator();
			while (projectIterator.next()) {
				eProject = aProject.getCurrentMember(projectIterator);
			}
		}
		return eProject;
	}

	public EWorkplan getWorkplan() throws SdaiException {

		eWorkplan = (EWorkplan) eProject.getMain_workplan(null);

		return eWorkplan;
	}

	public EWorkpiece getWorkpiece() throws SdaiException {
		
		aWorkpiece = eProject.getIts_workpieces(null);
		SdaiIterator workpieceIterator = aWorkpiece.createIterator();
		while (workpieceIterator.next()) {
			eWorkpiece = aWorkpiece.getCurrentMember(workpieceIterator);
		}
		return eWorkpiece;
		
	}
}
