package br.UFSC.GRIMA.Entity;

import static org.junit.Assert.fail;
import jsdai.SMachining_schema.EMaterial;
import jsdai.SMachining_schema.EProject;
import jsdai.SMachining_schema.EWorkpiece;
import jsdai.lang.EEntity;
import jsdai.lang.SdaiException;

import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import br.UFSC.GRIMA.STEPmanager.Util;

public class WorkpieceReaderTest {

	Util util = new Util();
	ProjectReader projectReader;
	WorkpieceReader workpieceReader;

	@Before
	public void startObjects() {
		try {
			projectReader = new ProjectReader(util.openFile21(Util
					.getUserPath()
					+ "test\\res\\STEP-NC File.p21"));
			EProject eProject = projectReader.getProject();
			EWorkpiece eWorkpiece = projectReader.getWorkpiece();
			workpieceReader = new WorkpieceReader(eWorkpiece);
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@After
	public void closeProject() {
		try {
			util.closeProject();
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void getNameTest() {
		try {
			String workpieceName = workpieceReader.getName();
			Assert.assertTrue(workpieceName.equals("Bauteil1"));
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}

	@Test
	public void getMaterialTest() {
		try {
			EMaterial eMaterial = workpieceReader.getMaterial();
			Assert.assertNotNull(eMaterial);
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}

	@Test
	public void getWorkpieceGlobal_ToleranceTest() {
		try {
			Double global_tolerance = workpieceReader.getGlobal_Tolerance();
			Assert.assertNotNull(global_tolerance);
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}

	@Test
	public void getBounding_GeometryTest() {
		try {
			EEntity bounding_geometry_select = workpieceReader
					.getBounding_Geometry();
			Assert.assertNotNull(bounding_geometry_select);
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
		/*
		 * 
		 * @Test public void getWorkpieceMaterialStd_identifierTest(){ try{
		 * projectReader = newProjectReader(util.openFile21(
		 * "C:\\Users\\Admin\\Eclipse\\StepNcMachining\\test\\res\\STEP-NC File.p21"
		 * )); workpieceReader = new
		 * WorkpieceReader(projectReader.getProject()); String
		 * materialStd_identifier =
		 * workpieceReader.getWorkpieceMaterialStd_identifier
		 * (projectReader.getProject()); util.closeProject();
		 * Assert.assertNotNull(materialStd_identifier); } catch (SdaiException
		 * e){ e.printStackTrace(); fail(); }
		 * 
		 * }
		 * 
		 * @Test public void getWorkpieceMaterialIdentifierTest(){ try{
		 * projectReader = newProjectReader(util.openFile21(
		 * "C:\\Users\\Admin\\Eclipse\\StepNcMachining\\test\\res\\STEP-NC File.p21"
		 * )); workpieceReader = new
		 * WorkpieceReader(projectReader.getProject()); String
		 * materialIdentifier =
		 * workpieceReader.getWorkpieceMaterialIdentifier(projectReader
		 * .getProject()); util.closeProject();
		 * Assert.assertNotNull(materialIdentifier); } catch (SdaiException e){
		 * e.printStackTrace(); fail(); }
		 * 
		 * }
		 * 
		 * @Test public void getWorkpieceMaterial_EPropertyTest(){ try{
		 * projectReader = newProjectReader(util.openFile21(
		 * "C:\\Users\\Admin\\Eclipse\\StepNcMachining\\test\\res\\STEP-NC File.p21"
		 * )); workpieceReader = new
		 * WorkpieceReader(projectReader.getProject()); EProperty_parameter
		 * ePropertyParameter =
		 * workpieceReader.getWorkpieceMaterial_Eproperty(projectReader
		 * .getProject()); util.closeProject();
		 * Assert.assertNotNull(ePropertyParameter); } catch (SdaiException e){
		 * e.printStackTrace(); fail(); }
		 * 
		 * }
		 * 
		 * @Test public void getWorkpieceMaterial_PropertyTest(){ try{
		 * projectReader = newProjectReader(util.openFile21(
		 * "C:\\Users\\Admin\\Eclipse\\StepNcMachining\\test\\res\\STEP-NC File.p21"
		 * )); workpieceReader = new
		 * WorkpieceReader(projectReader.getProject()); String propertyParameter
		 * =
		 * workpieceReader.getWorkpieceMaterial_Property(projectReader.getProject
		 * ()); util.closeProject(); Assert.assertNotNull(propertyParameter); }
		 * catch (SdaiException e){ e.printStackTrace(); fail(); }
		 * 
		 * } }
		 * 
		 * @Test public void getWorkpiecePositionTest(){ try{ projectReader =
		 * newProjectReader(util.openFile21(
		 * "C:\\Users\\Admin\\Eclipse\\StepNcMachining\\test\\res\\STEP-NC File.p21"
		 * )); workpieceReader = new
		 * WorkpieceReader(projectReader.getProject()); EEntity eEntity =
		 * workpieceReader
		 * .getWorkpieceBounding_Geometry(projectReader.getProject());
		 * EPlacement workpiecePosition =
		 * workpieceReader.getWorkpiecePosition(eEntity); util.closeProject();
		 * Assert.assertNotNull(workpiecePosition); } catch (SdaiException e){
		 * e.printStackTrace(); fail(); } }
		 * 
		 * @Test public void getWorkpieceSizeTest(){ try{ projectReader = new
		 * ProjectReader(util.openFile21(
		 * "C:\\Users\\Admin\\Eclipse\\StepNcMachining\\test\\res\\STEP-NC File.p21"
		 * )); workpieceReader = new
		 * WorkpieceReader(projectReader.getProject()); EEntity eEntity =
		 * workpieceReader
		 * .getWorkpieceBounding_Geometry(projectReader.getProject()); double[]
		 * size = workpieceReader.getWorkpieceSize(eEntity);
		 * util.closeProject(); for(int i = 0; i < size.length; i++) {
		 * System.out.println(size[i]);
		 * 
		 * } Assert.assertNotNull(size); } catch (SdaiException e){
		 * e.printStackTrace(); fail(); }
		 */
	}
}
