package br.UFSC.GRIMA.Entity;

import static org.junit.Assert.fail;
import jsdai.SMachining_schema.AExecutable;
import jsdai.SMachining_schema.EMachining_workingstep;
import jsdai.SMachining_schema.EProject;
import jsdai.SMachining_schema.ESetup;
import jsdai.SMachining_schema.EWorkplan;
import jsdai.lang.SdaiException;

import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import br.UFSC.GRIMA.STEPmanager.Util;

public class WorkplanReaderTest {

	Util util = new Util();
	ProjectReader projectReader;
	WorkplanReader workplanReader;

	@Before
	public void startObjects() {
		try {
			projectReader = new ProjectReader(util.openFile21(Util
					.getUserPath()
					+ "test\\res\\STEP-NC File.p21"));
			EProject eProject = projectReader.getProject();
			EWorkplan eWorkplan = projectReader.getWorkplan();
			workplanReader = new WorkplanReader(eWorkplan);
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@After
	public void closeProject() {
		try {
			util.closeProject();
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void getNameTest() {
		try {
			String workplanName = workplanReader.getName();
			Assert.assertTrue(workplanName.equals("Arbeitsplan"));
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}

	@Test
	public void getMachiningWorkingStepsTest() {
		try {
			AExecutable workplanElements = workplanReader.getMachiningWorkingSteps();
			Assert.assertNotNull(((EMachining_workingstep)workplanElements.getByIndexObject(1)).getIts_id(null).equals("Bohrung"));
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}

	}

	@Test
	public void getSetupTest() {
		try {
			ESetup workplanSetup = workplanReader.getSetup();
			Assert.assertNotNull(workplanSetup);
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}

}
